<% 
Sub GetHelp
   GenerateDisplayHeader "How to use this page"
   GenerateDisplayBodyHeader
%>
<P>On this page, you can send mail to your customers, affiliates or Drop Shippers/Suppliers.  This can be used for sending out newsletters to all customers, or it can even be used to simply remail an order confirmation.</P>
<P><strong>Form Fields</strong><br /><br />
<span name='help_emailfromaddress' id='help_emailfromaddress'>
	<strong>Email:</strong>	This field is set to the reply email address that will be used in your email, ie. if a customer receives your email and decides to reply to it, their reply will be sent to this email address.<br /><br />
</span>    
<span name='help_emailfromname' id='help_emailfromname'>
	<strong>Name:</strong>	This Field represents the name of the Person/Company from whom the mail is being sent, This will display as the From Name in your customer's mailing system.<br /><br />
</span>
<span name='help_emailsubject' id='help_emailsubject'>
	<strong>Subject:</strong>  This Field represents the subject of the email.<br /><br />
</span>
<span name='help_emailtype' id='help_emailtype'>
	<strong>Type:</strong>  This field represents the type of mailing interface that will be used to send the email.  In most cases this should be left as is.<br /><br />
</span>    
<span name='help_emailformat' id='help_emailformat'>
	<strong>Email Format:</strong>  This field represents the format of your email.  If your email contains HTML then set this value to "HTML".  If it is plain text, set it to "TEXT"<br /><br />
</span>
<span name='help_tablename' id='help_tablename'>
	<strong>Table Name:</strong>  This field represents the name of the table from which you will be retrieving your customers details.  It can be set to "customers", "orders", "affiliates", "suppliers".<br />
</span>
<span name='help_emailfilename' id='help_emailfilename'>
	<strong>File Name:</strong>  This field represents the name of your mailing Template that you will be using to format your email.  If you are not using a Template, you should leave this field empty.<br /><br />
</span>
<span name='help_attachmentfilename' id='help_attachmentfilename'>
	<strong>Attachment:</strong>  This field represents the physical path to your attachment file, eg. c:\attachments\attachment.txt.  If you do not want to attach any files to your email you can leave this field blank.<br /><br />
</span>
<span name='help_emailuseTemplate' id='help_emailuseTemplate'>
	<strong>Merge with Database:</strong>  If your Template needs to access certain fields from the Database, eg. if you are remailing an order confirmation, then this needs to be set to "Yes".  Otherwise, you should set this to no.<br /><br />
</span>
<span name='help_message' id='help_message'>
	<strong>Message:</strong>  If you are not using a Template to format your email, you can enter your text into this field.  If you are using a Template then this field should be left empty.<br /><br /><br />
</span>
	<strong>Example - Re-Mailing a customer's order confirmation:</strong><br /><br />
	<ol>
		<li>Set the Email field to "orders@yoursite.com"</li>
		<li>Set the Name field to "Your business"</li>
		<li>Set the Subject field to "Order Confirmation"</li>
		<li>Leave the type field empty</li>
		<li>Set the Email Format field to "HTML"</li>
		<li>Set the Table Name field to "orders"</li>
		<li>Set the File Name field to "tmp_customeremail.htm"</li>
		<li>Leave the Attachment field empty</li>
		<li>Set the Merge with Database field to "Yes"</li>
		<li>Leave the Message field empty</li>
		<li>Click Continue</li>
		<li>You will be transferred to a list of orders.  Select the orders that you would like to re-mail</li>
		<li>Click the "Mail Selected Records" button at the bottom of the Page</li>
	</ol>
<%
   GenerateDisplayBodyFooter
end sub
%>