<%option explicit%>
<%response.buffer=true%>
<!--#include file="shop$db.asp"-->
<%ShopOpenDatabase dbc%>
<!--#include file="shopproductfeatures.asp"-->
<!--#include file="shopproductformat.asp"-->
<!--#include file="shopreviewaverage.asp"-->
<!--#include file="shopproductcreatesql.asp"-->
<!--#include file="shopproductformat_Template.asp"-->
<!--#include file="shopreadfile.asp"-->
<!--#include file="shopproductinventory.asp"-->
<!--#include file="shopalsobought.asp"-->
<%
'*********************************************************************************
' 7.00
' 1 Dec 2009
' Main program logic for displaying products.
'*********************************************************************************

'700 - 2010.07.08 - Enhancement: Always redirect to SEO link if SEO Dynamic enabled
if ucase(getconfig("xSEODynamicEnable"))="YES" and ucase(getconfig("xSEODynamicProductsEnable")) = "YES" and instr(lcase(request.servervariables("SCRIPT_NAME")),"shopdisplayproducts.asp") > 0 then
   dim exdID
   dim friendlyURL
   dim currPage
	
   if not isNumeric(request("Page")) then
      currPage = ""
   else
      currPage = request("Page")
   end if
   
   '701 - 2010.12.15 - Bug Fix: Filtering is not working properly with breadcrumb
   if request("filter") <> "yes" then exdID = request("id")
   
   if not isNumeric(exdID) then
      shopclosedatabase dbc
      response.end
   else
      'if no ID is provided, then do nothing and display all products like the standard shopdisplayproducts.asp
      if exdID <> "" then
         dim catRS
         dim catName
         dim catSubCategory

         Set catRS = Server.CreateObject("ADODB.Recordset")
         '700 - 2010.09.26 - Enhancement: Speed up front store performance
         catRS.open "Select categoryid,catdescription,hassubcategory from categories where categoryid = " & exdID, dbc, adOpenForwardOnly, adLockReadOnly
         if not catRS.eof then
            catName = catRS("catdescription")
            catSubCategory = catRS("hassubcategory")
            genseocategoryproductlink friendlyURL,exdID,catName,catName,catSubCategory,"No"
            closerecordset catRS
            '301 redirection code
            Response.Status="301 Moved Permanently"
            if currPage <> "" then
               Response.AddHeader "Location", xmysite & "/"& friendlyURL & "default.asp?page=" & currPage
            else
               Response.AddHeader "Location", xmysite & "/"& friendlyURL
            end if
            shopclosedatabase dbc
            response.end
         else	
            closerecordset catRS
            Response.Status="301 Moved Permanently"
            Response.AddHeader "Location",xmysite
            shopclosedatabase dbc
            response.end
         end if
      end if
   end if
end if

dim search
dim PRODUCTNAME, CatalogId
dim ProductFields
dim ProductCaptions
dim ProductFieldCount
dim ProductSelect
dim Colcount, totalcolcount
dim ProductMaxColumns, Productwithhtml
dim yfieldnames, Sortnames, yfieldcount, sortcount
dim displayfields, displayfieldcount, displaycaptions
dim sortcaptions, yfieldcaptions
dim sortupdownnames(3), sortupdownvalues(3), sortupdowncount
dim sortfield, sortupdown, selectfield, i
dim sortfield2, sortupdown2
dim rc
dim InventoryCheck, InventoryPriceDisplay, inventoryquantitydisplay, inventoryoutofstock

InitializeSystem
ProductmaxColumns = GetConfig("xproductcolumns")
ProductwithHtml = GetConfig("xProductwithhtml")
if productmaxcolumns = "" then
   productmaxcolumns = 1
end if
productmaxcolumns = clng(productmaxcolumns)
if Productmaxcolumns>1 then
   Productwithhtml = "Yes"
end if
ProductSelect = GetConfig("xProductSelect")
SetSess "CurrentUrl", "shopdisplayproducts.asp"
mypage = request.querystring("page")

'700 - Paging Navigation - bookmark
if len(mypage) <= 0 then mypage = 1

'6.08 Fix
'700 - 2010.08.10 - Enhancment: Update language reference
if not isnumeric(mypage) then ShopError getlang("langpagezienumeric")

mypagesize = GetConfig("xProductsPerPage")
if Request.QueryString("sppp") <> "" and isnumeric(Request.QueryString("sppp")) then
   '6.50 - precautionary security fix
   if isnumeric(Request.QueryString("sppp")) then
      mypagesize = Request.QueryString("sppp")
   end if
end if

'6504 - BUG FIXS - No upper limit to sppp variable
if mypagesize > 100 or mypagesize < 0 then mypagesize = 100
if GetConfig("xproductfiltering") = "Yes" then
   GetFilteringFields
   SetupFiltering
   if trim(getsess("proditemsperpage")) <> "" then
      if isnumeric(getsess("proditemsperpage")) = true then
	     mypagesize = getsess("proditemsperpage")
	  end if
   end if
end if

'If there is no page, then we must generate sql otherwise sqlis in session(sqlQuery)
'700 - Paging Navigation
if mypage = "" or cstr(mypage) = "1" then
   mypage = 1
   ProcessFirst
   createsql
else
   'sql = GetSess("sqlquery")
   '700 - Paging Navigation - bookmark page2, page3 for the category
   if sql="" then
      ProcessFirst
      createsql
   end if
   Category = GetSess("Category")
   Subcat = GetSess("Subcat")
   cat_id = GetSess("Cat_id")
end if

SetSess "pagenumber", mypage

'700 - 2010.09.01 - Bug Fix: Displaying products lisings should be no result if specific category set to hidden
'700 - 2010.09.24 - Enhancement: To include xcathideproduct control
if getconfig("xcathideproduct") = "Yes" then
   if checkcategoryhidden(cat_id) then shoperror GetLang("langProductSearch")
end if

SetupdynamicCategory dbc, cat_id
WriteImpressions
ShopPageHeader
DisplayProducts
ShopPageTrailer

'700 - 2010.06.24 - Enhancement: Better handling breadcrumb at shopdisplayproducts.asp
setsess "seocategoryid", ""

ShopCloseDatabase dbc

'Process first time
sub ProcessFirst()
   CAT_ID = cleanchars(Request("id"))
   if not isnumeric(CAT_ID) then CAT_ID = ""
   
   '700 - 2010.05.27 - Bug Fix: Category Header still remained while searching products
   if lcase(request("search")) <> "yes" then
      '700 - SEO
      getseocat_id CAT_ID
	  
	  '700 - 2010.09.22 - Bug Fix: Breadcrumb not displaying after search product
	  session("seocbc") = ""
   end if
   
   if cat_id <> "" and request("filter") <> "yes" then
      setsess "sqlfilterflag",""
   end if

   CATEGORY = Request("cat")
   if lcase(request("search")) <> "yes" then
      '700 - SEO
      getseocat_name CATEGORY,CAT_ID
   end if

   '6.09 - security update
   category = CleanChars(category)
   SUBCAT = cleanchars(Request("subcat"))
   '6.09 - security update
   if not isnumeric(subcat) then subcat = ""

   PRODUCTNAME = Request("PRODUCT")
   '6.09 - security update
   productname = CleanChars(productname)

   CatalogId = cleanchars(Request("CatalogId"))
   if not isnumeric(CatalogId) then CatalogId = ""
   SetSess "Category", CATEGORY
   SetSess "Subcat", subcat
   SetSess "cat_id", cat_id
   SetSess "displayTemplate", ""
end sub

sub DisplayProducts()
   dim header
   dim recordcount
   dim words
   dim wordcount
   dim i
   dim msg
   dim rc, url, stayonpage
   dim objrs1
   Header = ""
   if category <> "" then
      header = header & Category
   else
      header = header & GetLang("langProduct01")
      header = ""
   end if
   if lcase(request("search")) <> "yes" then
      GenerateCategoryLinks header
      '6.50 - added config option to turn breadcrumb on/off
      if GetConfig("xbreadcrumbs") = "Yes" then
         if trim(header) <> "" then
            htmlwrite "<div class=""breadcrumb"">" & header & "</div>"
	     end if
      end if
   else
      '700 - 2010.06.24 - Enhancement: Better handling breadcrumb at shopdisplayproducts.asp
      if GetConfig("xbreadcrumbs") = "Yes" then
         header = "<div class=""breadcrumb""><a href=""" & GetConfig("xhome") & """>" & GetLang("langcommonhome") & "</a>&nbsp;" & SubCatSeparator & GetLang("langcommonsearch") & "</div>"
	     htmlwrite "<div class=""breadcrumb"">" & header & "</div>"

		 '7.01 - 2010.10.06 - Bug Fix: Breadcrumb issue if xGenerateShopexdLink = No
		 SetSess "breadcrumb", ""
	  end if
   end if
      
   htmlwrite "<div class=""main-product"">"
   if Category <> "" then
      htmlwrite "<h1>" & Category & "</h1>"
   else
      htmlwrite "<h1>" & GetLang("langProduct01") & "</h1>"
   end if
   ShowCategoryImage
   ShopOpenRecordSet SQL, objRS1, mypagesize, mypage

   '700 - 2010.06.22 - Enhancement: Google not catching invalid pages
   if cdbl(mypage) > cdbl(maxpages) then 
      Response.Status="301 Moved Permanently"
	  
	  '700 - 2010.09.10 - Bug Fix: If invalid pages at display products listings page, it should display No products Match your search
	  session("ShopError") = GetLang("langProductSearch")
      Response.AddHeader "Location", xmysite2 & "/shoperror.asp"
   end if

   '700 - paging navigation - moveback to the first column
   'objrs1.movefirst
   if objRS1.eof then
      objRS1.close
      set objRS1 = nothing
      ShopWriteError GetLang("langProductSearch")
	  htmlwrite "</div>"
      exit sub
   end if
   recordcount = 0
   htmlwrite "<p class=""ac"">" & smallinfofont & GetLang("langCommonPage") & " " & mypage & GetLang("langCommonOf") & " " & maxpages
   htmlwrite "&nbsp;"
   if getconfig("xproductpagingnextprevious")="Yes" then
      Call PageNavBarNext (SQL)
   else
      Call PageNavBar (SQL)
   end if
   htmlwrite smallinfoend & "</p>"
   
   if GetConfig("xproductfiltering") = "Yes" then
      Displayfiltering "faction1"
   end if
   if ProductSelect = "Yes" then
      htmlwrite "<form name=""form1"" method=""post"" action=""" & genredirecturl("shopproductselect.asp") & """>"
      Prodindex = 0
   else
      Prodindex = ""
   end if
   if ProductwithHtml<>"Yes" then
      ProductFormatHeader
   else
      htmlProductFormatHeader
   end if
'   dim tempcatalogid, passflag
'   tempcatalogid = ""
'   passflag = false

   '700 - 2010.09.29 - Enhancement: Speed up front store performance
   session("findactuallink") = "yes"
   session("findactuallinkcategoryid") = ""
   session("findactuallinkcategoryname") = ""
   session("findactuallinkbprocess") = ""

   while not objRS1.eof and recordcount < maxrecs
      'if objrs1("catalogid") = 
      'tempcatalogid = objrs1("catalogid")
      'debugwrite objrs1("catalogid") & "AA"
      GetProductRecordset objrs1, objrs
      ProductGetValues objRS, dbc ' get product values
      Inventorycheck = false ' no sub products
      InventoryPriceDisplay = true ' display prices with sub products
      Inventoryoutofstock = false ' there are inventory products to display
      InventoryProductYesNo dbc, objrs, lngCatalogId, inventorycheck, Inventorypricedisplay, Inventoryquantitydisplay, inventoryoutofstock
      if Productwithhtml<>"Yes" then
         ProductFormatRow
      else
         htmlProductFormatRow
      end if
      if ProductSelect = "Yes" then
	     if trim(ProdIndex) = "" then ProdIndex = 0
         ProdIndex = ProdIndex + 1
      end if
      objRS1.MoveNext
      CloseRecordSet objrs
      recordcount = recordcount + 1
      colcount = colcount + 1
      totalcolcount = totalcolcount + 1
      if colcount>= ProductMaxColumns and ProductMaxcolumns>1 then
         response.write "</tr>"
         colcount = 0
      end if
   wend

   '700 - 2010.09.29 - Enhancement: Speed up front store performance
   session("findactuallink") = ""
   session("findactuallinkcategoryid") = ""
   session("findactuallinkcategoryname") = ""
   session("findactuallinkbprocess") = ""

   FillRemainingColumns
   response.write "</table>"
   if ProductSelect = "Yes" and GetConfig("xproductcatalogonly") <> "Yes" then
      response.write "<input type=""hidden"" name=""prodindex"" value=""" & ProdIndex & """ />"
	  
	  '701 - 2011.08.16 - Bug Fix: button display incorrectly at shopdisplayproducts page when xproductselect = Yes
	  htmlwrite "<div class=""selectproductbuttonwrapper"">"
      ShopButton GetConfig("xbuttonorderproduct"), GetLang("langProductSelectButton"), "action"
	  response.write "&nbsp;"
      ShopButtonReset GetConfig("xbuttonreset"), GetLang("langCommonReset"), ""
	  htmlwrite "</div>"
	  
      stayonpage = GetConfig("Xproductstayonpage")
      if stayonpage = "Yes" then
         
		 '700 - 2010.04.16 - Search Stay on page
		 if lcase(request.QueryString("search")) = "yes" then
		    url = "shopdisplayproducts.asp?Search=Yes&page=" & mypage & ""
         else
   		    url = "shopdisplayproducts.asp?page=" & mypage & "&id="& CAT_ID &"&cat="& CATEGORY &""
		 end if

         response.write "<input type=""hidden"" name=""ReturnURL"" value=""" & url & """ />"
      end if

      '6.50 - advanced session handling
      Addwebsessform
      response.write("</form>")
   end if

   htmlwrite "<p class=""ac"">" & smallinfofont & GetLang("langCommonPage") & " " & mypage & GetLang("langCommonOf") & " " & maxpages
   htmlwrite "&nbsp;"
   if getconfig("xproductpagingnextprevious")="Yes" then
      Call PageNavBarNext (SQL)
   else
      Call PageNavBar (SQL)
   end if
   htmlwrite smallinfoend & "</p>"
   objRS1.close
   set objRS1 = nothing
   if GetConfig("xproductfiltering") = "Yes" then
      Displayfiltering "faction2"
   end if
   htmlwrite "</div>"
end sub

'If DisplayCategoryImages is set to Yes
'Displays the CatImage if there are not subcategories
'Display file associates with actegory
'Displays the SubCatImage if there is
sub ShowCategoryImage
   dim ImageFileName, description, i
   '6.50 - add alt tag to images
   dim categoryname

   dim rs
   dim query
   imagefilename = ""
   if cat_id = "" then exit sub
   if GetConfig("xDisplayCategoryImages") = "Yes" or GetConfig("xdisplaycategoryfiles") = "Yes" then
      query = "select * from categories where categoryid = " & cat_id
      Set rs = Server.CreateObject("ADODB.Recordset")
      '700 - 2010.09.26 - Enhancement: Speed up front store performance
	  '701 - 2011.03.15 - Enhancement: Speed up store performance
      rs.open query, dbc, adOpenForwardOnly, adLockReadOnly
      if not rs.eof then
         imagefilename = rs("catimage")
         description = rs("catextra")

         '6.50 - add alt tag to images
         categoryname = rs("catdescription")

         if isnull(imagefilename) then
            imagefilename = ""
         end if
         if isnull(description) then
            description = ""
         end if
      end if
      CloseRecordSet rs
   else
      exit sub
   end if
   if GetConfig("xDisplayCategoryImages") = "Yes" and imagefilename<>"" then
      '6.50 - add alt tag to images
      htmlwrite "<p class=""ac""><img border=""0"" src=""" & ImageFileName & """ alt=""" & categoryname & """ /></p>"
   end if
   if GetConfig("xdisplaycategoryfiles") = "Yes" and description <>"" then
      dim readarray(9999), readcount
      readcount = 0
      ShopReadFile description, ReadArray, readcount
      if readcount = 0 then exit sub
      htmlwrite "<br />"
      for i = 0 to readcount -1
         htmlwrite readarray(i) & vbcrlf
      next
   end if
end sub

' sql is actually created in shopproductcreatesql, it can be complex or it could have been created by search
sub createsql
   '700 - Paging Navigation
   dim search,keyword,mypage,sppp,category,highprice,lowprice,allwords,exact,atleast,without,bc,queryprefix,cname
   search = Request.querystring("Search")
   keyword = Request.querystring("keyword")
   mypage = Request.querystring("page")
   sppp = Request.querystring("sppp")
   category = Request.querystring("category")
   highprice = Request.querystring("highprice")
   lowprice = Request.querystring("lowprice")
   allwords = Request.querystring("allwords")
   exact = Request.querystring("exact")
   atleast = Request.querystring("atleast")
   without = Request.querystring("without")
   bc = Request.querystring("bc")
   queryprefix = Request.querystring("queryprefix")
   cname = Request.querystring("cname")
   CatalogId = Request.querystring("CatalogId")
   
   '700 - 2010.09.01 - Bug Fix: Advanced Searching is not working with Search Fields
   dim searchfields
   searchfields = Request.querystring("searchfields")

   if search<>"" then
      setsess "sqlfilterflag",""
	  
	  '701 - 2010.12.15 - Bug Fix: Filtering is not working properly with breadcrumb
      SetSess "Prodsortfield", ""
      SetSess "prodsortupdown", ""
      SetSess "proditemsperpage", ""
      SetSess "prodlowprice", ""
      SetSess "prodhighprice", ""
	  
      SQL = GetSess("SQL")
	  if len(SQL) > 0 then
	     if len(queryprefix) > 0 and len(cname) > 0 then
		    if instr(lcase(SQL),"p.cname") <= 0 then
			   sql = ""
            else
			   if instr(lcase(SQL),"p.cdescription") > 0 then
			      sql = ""
			   end if
			end if
         elseif len(keyword) > 0 or len(without) > 0 or len(atleast) > 0 or len(exact) > 0 or len(allwords) > 0 then
		    '700 - 2010.09.01 - Bug Fix: Advanced Searching is not working with Search Fields
		    if instr(getconfig("xsearchfields"),"cdescription") > 0 and instr(searchfields,"cdescription") > 0 then
			   if instr(lcase(SQL),"p.cdescription") <= 0 then
			      sql = ""
  			   end if
			end if
         elseif len(category) > 0 and ucase(category) <> "ALL" then
			    if instr(lcase(SQL),"cc.intcategoryid =") <= 0 then
			   sql = ""
			end if
         elseif ucase(category) = "ALL" then
		    if instr(lcase(SQL),"p.cdescription")> 0 or instr(lcase(SQL),"p.cname") > 0 or instr(lcase(SQL),"cc.intcategoryid =") > 0 then
			   sql = ""
			end if
		 end if
	  end if
	  
	  '700 - Paging Navigation
	  if len(request("Template")) <= 0 then
   	     if sql="" then
	        if len(bc) <= 0 then
			   '700 - 2010.09.01 - Bug Fix: Advanced Searching is not working with Search Fields
	           ResponseRedirect "shopsearch.asp?Search="& search &"&Keyword="& keyword &"&page="& mypage &"&howmanyitems=" & sppp & "&category=" & category & "&highprice=" & highprice & "&lowprice=" & lowprice & "&allwords=" & allwords & "&exact=" & exact & "&atleast=" & atleast & "&without=" & without & "&searchfields="& searchfields &""
            else
			   '700 - 2010.09.01 - Bug Fix: Shopquery return wrong results
			   if lcase(search) = "yes" then
			      ResponseRedirect "shopquery.asp?"& request.ServerVariables("QUERY_STRING") &""
			   else
	   	          ResponseRedirect "shopquery.asp?queryprefix="& queryprefix &"&cname="& cname &"&page="& mypage &"&CatalogId="& CatalogId &""
			   end if
		    end if
	     end if
	  end if
	  
      SetSess "sqlnofilter", sql
      exit sub
   end if

   SQL = GetSess("SQL")
   '701 - 2010.12.15 - Bug Fix: Filtering is not working properly with breadcrumb
   if lcase(trim(getsess("sqlfilterflag"))) <> "yes" or len(request("Template")) > 0 then
      SetSess "Prodsortfield", ""
      SetSess "prodsortupdown", ""
      SetSess "proditemsperpage", ""
      SetSess "prodlowprice", ""
      SetSess "prodhighprice", ""
      Productcreatesql sql, dbc
   end if
   SetSess "sqlnofilter", sql
   exit sub
end sub

'If we are doing multiple columns, fill them up
sub FillRemainingColumns
   if productmaxcolumns = 1 then exit sub
   if colcount = 0 then exit sub
   if totalcolcount<productmaxcolumns then
      response.write "</tr>"
      exit sub
   end if
   do while Colcount<productMaxColumns and colcount>0
      response.write "<td>&nbsp;</td>"
      colcount = colcount + 1
   loop
   response.write "</tr>"
end sub

'Filtering allows customers to restort displayed products
sub SetupFiltering
   redim yfieldnames(50)
   redim sortnames(50)
   redim sortcaptions(50)
   redim yfieldcaptions(50)
   GetFieldNames
   SetUpDown sortupdownnames, sortupdownvalues, sortupdowncount
   if displayfieldcount = "" then
      DisplayFields = yFieldnames
      Displayfieldcount = 0
   end if
end sub

'filtering form is formatted
sub displayfiltering (buttonname)
   dim itemsperpages(10),itemsperpagesvalues(10)
   setupitemsperpages itemsperpages,itemsperpagesvalues
   htmlwrite "<div class=""sort_product_container"">"
   
   '701 - 2010.12.15 - Bug Fix: Filtering is not working properly with breadcrumb
   if request.QueryString("search") <> "Yes" then
      htmlwrite "<form name=""filter"" action=""shopfiltering.asp?id="& cat_id &"&cat="& category &""" method=""post"">"
   else
	  htmlwrite "<form name=""filter"" action=""shopfiltering.asp"" method=""post"">"
   end if

   '700 -2010.06.22 - Enhancement: Make currency symbol at filitering is dynamic
   dim filtercursymbol
   filtercursymbol = getsess("Newcurrencysymbol")
   if trim(filtercursymbol) <> "" then
      if filtercursymbol = "US$" then
	     filtercursymbol = "$"
	  else
         filtercursymbol = getsess("Newcurrencysymbol")
	  end if
   else
      filtercursymbol = "$"
   end if
   htmlwrite "<label>"& getlang("LangProductPrice") &" "& filtercursymbol &"</label>"
   htmlwrite "<input size=""10"" name=""lowprice"" class=""txtfield inputfield"" value="""& getsess("prodlowprice") &""" />"
   htmlwrite "<label>"& getlang("langcommonto") &" "& filtercursymbol &"</label>"
   htmlwrite "<input size=""10"" name=""highprice"" class=""txtfield inputfield"" value="""& getsess("prodhighprice") &""" />"

   GenerateSelectVStyle itemsperpages, itemsperpagesvalues, getsess("proditemsperpage"), "itemsperpage", 5, ""
   GenerateSelectVStyle sortcaptions, sortnames, getsess("Prodsortfield"), "sortfield", sortcount, GetLang("langCommonSelect")
   GenerateSelectVStyle Sortupdownnames, Sortupdownvalues, getsess("prodsortupdown"), "sortupdown", sortupdowncount, ""
   ShopButton GetConfig("xbuttoncontinue"), GetLang("langcommongo"), buttonname
   htmlwrite "</form>"
   htmlwrite "<div class=""cb""></div>"
   htmlwrite "</div>"
   htmlwrite "<div class=""cb""></div>"
end sub

sub setupitemsperpages (itemsperpages,itemsperpagesvalues)
   itemsperpages(0) = "10 "& getlang("LangSearchItemsPerPage") &""
   itemsperpagesvalues(0) = "10"
   itemsperpages(1) = "20 "& getlang("LangSearchItemsPerPage") &""
   itemsperpagesvalues(1) = "20"
   itemsperpages(2) = "30 "& getlang("LangSearchItemsPerPage") &""
   itemsperpagesvalues(2) = "30"
   itemsperpages(3) = "40 "& getlang("LangSearchItemsPerPage") &""
   itemsperpagesvalues(3) = "40"
   itemsperpages(4) = "50 "& getlang("LangSearchItemsPerPage") &""
   itemsperpagesvalues(4) = "50"
end sub

sub Displayfiltering_old
   response.write "<form name=""filter"" action=""shopfiltering.asp"" method=""post"">"
   response.write Productfilteringtable
   response.write productfilteringrow
   response.write productfilteringcolumn & GetLang("langEditSort") & Productfilteringcolumnend
   response.write productfilteringcolumn & GetLang("langEditSort") & " 2" & Productfilteringcolumnend
   response.write productfilteringcolumn & GetLang("langEditDisplay") & Productfilteringcolumnend
   response.write "</tr>"
   response.write productfilteringrow
   response.write ProductFilteringColumn
   response.write "&nbsp;"
   GenerateSelectV sortcaptions, sortnames, sortfield, "sortfield", sortcount, GetLang("langCommonSelect")
   response.write "</p><p class=""ac"">&nbsp;"
   GenerateSelectV Sortupdownnames, Sortupdownvalues, sortupdown, "sortupdown", sortupdowncount, ""
   response.write Productfilteringcolumnend
   response.write ProductFilteringColumn
   response.write "&nbsp;"
   GenerateSelectV sortcaptions, sortnames, sortfield2, "sortfield2", sortcount, GetLang("langCommonSelect")
   response.write "</p><p class=""ac"">&nbsp;"
   GenerateSelectV Sortupdownnames, Sortupdownvalues, sortupdown2, "sortupdown2", sortupdowncount, ""
   response.write Productfilteringcolumnend
   response.write ProductFilteringColumn & "<p>"
   GenerateSelectV yfieldcaptions, yfieldnames, SelectField, "SelectField", yfieldcount, GetLang("langCommonSelect")
   response.write "</p><p>"
   response.write "<input type=""text"" name=""SelectValue"" size=""20"" class=""txtfield"" /></p>"
   response.write Productfilteringcolumnend
   response.write "</tr>"
   response.write productfilteringrow
   response.write ProductFilteringColumn
   response.write Productfilteringcolumnend
   response.write ProductFilteringColumn
   if GetConfig("Xbuttonreset") = "" then
      response.write("<input class=""submitbtn"" type=""reset"" value=""" & GetLang("langCommonReset") & """ />")
   else
      response.write("<img src=""" & GetConfig("xbuttonreset") & """ onclick=""document.filter.reset()"" />")
   end if
   response.write Productfilteringcolumnend
   response.write ProductFilteringColumn
   ShopButton GetConfig("xbuttoncontinue"), GetLang("langCommonContinue"), "action"
   response.write Productfilteringcolumnend
   response.write "</tr>"
   response.write "</table>"
   response.write "</form>"
end sub

sub GetFieldNames
   dim prodfields, prodheaders, ucfield, i
   sortcount = 0
   yfieldcount = 0
   SetupProductFields ProdFields, ProdHeaders
   for i = 0 to ubound(prodfields)
      ucfield = trim(ucase(prodfields(i)))
      if ucfield<>"QUANTITY" then
         yfieldnames(yfieldcount) = prodfields(i)
         yfieldcaptions(yfieldcount) = trim(prodheaders(i))
         yfieldcount = yfieldcount + 1
         if ucfield = "CDESCRIPTION" then
         else
            sortnames(sortcount) = prodfields(i)
            sortcaptions(sortcount) = prodheaders(i)
            sortcount = sortcount + 1
         end if
      end if
   next
end sub

sub SetUpDown (sortupdownnames, sortupdownvalues, sortupdowncount)
   Sortupdownnames(0) = "Asc"
   Sortupdownnames(1) = "Dec"
   Sortupdownvalues(0) = "ASC"
   Sortupdownvalues(1) = "DESC"
   SortUpDowncount = 2
end sub

sub GetFilteringFields
   yFieldcount = GetSess("prodFieldcount")
   yFieldnames = GetSessA("prodFieldnames")
   sortfield = GetSess("prodsortfield")
   sortfield2 = GetSess("prodsortfield2")
   sortupdown = GetSess("prodsortupdown")
   DisplayFields = GetSess("prodDisplayFields")
   DisplayFieldCount = GetSess("prodDisplayCount")
   Displaycaptions = GetSessA("Proddisplaycaptionsall")
   sortfield = ""
   sortfield2 = ""
end sub

sub GenerateSelectMULTV (iFieldnames, ifieldvalues, fieldcount, currentvalues, currentvaluecount, selectname, firstfield)
%>
<select multiple size="5" name="<%=selectname%>">
<%
   dim Currentvalue
   dim j
   dim found
   Currentvalue = ""
   if firstfield<>"" then
      response.write "<option>" & firstfield & "</option>"
   end if
   for i = 0 to fieldcount -1
      if currentvaluecount> 0 then
         Found = "FALSE"
         j = 0
         do while found = "FALSE" and j < currentvaluecount
            if iFieldvalues(i) = Currentvalues(j) then
               currentvalue = ifieldvalues(i)
               found = "TRUE"
            end if
            j = j + 1
         loop
      end if
      if currentvalue = ifieldvalues(i) then
         response.write "<option value=""" & ifieldvalues(i) & """ selected=""selected"">" & iFieldnames(i) & "</option>"
      else
         response.write "<option value=""" & ifieldvalues(i) & """>" & ifieldnames(i) & "</option>"
      end if
   next
%>
</select>
<%
end sub

'Get recordset for real product
sub GetProductRecordset (objrs1, objrs)
   dim CatalogId
   CatalogId = objrs1("CatalogId")
   dim sql
   sql = "select * from products where CatalogId=" & CatalogId
   Set objrs = Server.CreateObject("ADODB.Recordset")
   '700 - 2010.09.26 - Enhancement: Speed up front store performance
   objrs.open sql, dbc, adOpenStatic, adLockOptimistic
end sub

'generate category links
sub GenerateCategoryLinks (header)
   '6.09 - added breadcrumb
   if cat_id = "" then
      if request("bc") <> "no" and lcase(request("search")) <> "yes" then
         '6.50 - added config option to turn breadcrumb on/off
         if GetConfig("xbreadcrumbs") = "Yes" then
            '6.50 - advanced session handling
            response.write "<div class=""breadcrumb""><a href=""" & GetConfig("xhome") & addwebsesslinkfirst & """>" & GetLang("langcommonhome") & "</a>&nbsp;" & SubCatSeparator & "<a href=""shopdisplaycategories.asp" & Addwebsesslinkfirst & """>" & GetLang("LangCommonCategories") & "</a>" & subcatseparator & GetLang("langproductproduct") & "</div>"
         end if
      elseif lcase(request("search")) = "yes" then
         response.write "<div class=""breadcrumb""><a href=""" & GetConfig("xhome") & """>" & GetLang("langcommonhome") & "</a>&nbsp;" & SubCatSeparator & GetLang("langcommonsearch") & "</div>"
      end if
      exit sub
   end if
   if GetConfig("xproductcategorylinks")<>"Yes" then exit sub
   dim highercatid, cats(10), catids(10), i, mylink, categoryid
   dim cathead, more, catsql, rs
   dim id, name
   cathead = ""
   More = true
   i = 0
   highercatid = cat_id
   do while more = true
      catsql = "select * from categories where categoryid=" & highercatid
      Set rs = Server.CreateObject("ADODB.Recordset")
      '700 - 2010.09.26 - Enhancement: Speed up front store performance
	  '701 - 2011.03.15 - Enhancement: Speed up store performance
      rs.open catsql, dbc, adOpenForwardOnly, adLockReadOnly
      if not rs.eof then
         highercatid = rs("highercategoryid")
         categoryid = rs("categoryid")
         name = rs("catdescription")
         id = rs("categoryid")
         name = TranslateLanguage(dbc, "categories", "catdescription", "categoryid", categoryid, name)

         '6.50 - advanced session handling
         if i = 0 then
            mylink = "<a href=""shopdisplayproducts.asp?id=" & categoryid & Addwebsesslink & "&amp;cat=" & Server.URLEncode(name) & """>" & name & "</a>"
		    '700 - SEO
	        genseocategoryproductlink mylink,rs("categoryid"),name,name,"","Yes"
         else
            mylink = "<a href=""shopdisplaycategories.asp?id=" & categoryid & Addwebsesslink & "&amp;cat=" & Server.URLEncode(name) & """>" & name & "</a>"
		    '700 - SEO
	        genseocategoryproductlink mylink,rs("categoryid"),name,name,"Yes","Yes"
         end if

         cats(i) = mylink
         i = i + 1
         if highercatid = 0 then
            more = false
         end if
      else
         more = false
      end if
      CloseRecordSet rs
   loop

   '6.09 - added breadcrumb
   '6.50 - advanced session handling
   mylink = "<a href=""" & GetConfig("xhome") & addwebsesslinkfirst & """>" & GetLang("langcommonhome") & "</a>&nbsp;" & SubCatSeparator & "<a href=""shopdisplaycategories.asp"">" & GetLang("LangCommonCategories") & "</a>"
   cats(i) = mylink
   i = i + 1

   for i = 0 to i -1
      if cathead = "" then
         cathead = cats(i)
      else
         cathead = cats(i) & subcatseparator & "&nbsp;" & cathead
      end if
   next
   header = cathead
   SetSess "breadcrumb", cathead
end sub

sub WriteImpressions
   if CAT_ID <> "" then
      '701 - 2012.02.07 - Bug Fix: Product/category impressions is not updated if impressions is null
      dbc.execute("UPDATE categories SET impressions = 0 WHERE impressions is null")
      'increment category impressions
      dbc.execute("UPDATE categories SET impressions = impressions + 1 WHERE categoryid = " & CAT_ID)
   end if
end sub

'700 - 2010.09.01 - Bug Fix: Displaying products lisings should be no result if specific category set to hidden
function checkcategoryhidden (cat_id)
   dim catsql,rs,tempflag
   tempflag = false
   
   if trim(cat_id) <> "" then
      catsql = "select cathide from categories where categoryid=" & cat_id
      Set rs = Server.CreateObject("ADODB.Recordset")
      '700 - 2010.09.26 - Enhancement: Speed up front store performance
	  '701 - 2011.03.15 - Enhancement: Speed up store performance
      rs.open catsql, dbc, adOpenForwardOnly, adLockReadOnly
      if not rs.eof then
         if isnull(rs("cathide")) = false then 
            if ucase(rs("cathide")) = "YES" or cstr(rs("cathide")) = "1" or rs("cathide") = true then tempflag = true
	     end if
      end if
      CloseRecordSet rs
   end if
   
   checkcategoryhidden = tempflag
end function
%>